﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace UkazkaDekompozice
{
    public interface GraveYardManager
    {
        void burryBodyIntoGrave(Body body, Grave grave);
        void removeBodyFromGrave(Body body, Grave grave);
        Grave findGraveWithBody(Body body);
        IList<Body> getBodiesInGrave(Grave grave);
    }

    public interface BodyManager
    {
        void createBody(Body body);
        void updateBody(Body body);
        void removeBody(Body body);
        Body findBodyWithId(long id);
        IList<Body> findBodiesByName(string name);
        IList<Body> findAllBodies();
    }

    public interface GraveManager
    {
        void createGrave(Grave grave);
        void updateGrave(Grave grave);
        void removeGrave(Grave grave);
        Grave findGraveById(int id);
        IList<Grave> findAllGraves();

    }





    public class Program
    {
        static void Main(string[] args)
        {
            GraveYardManager manager = new MemoryGraveYardManager();
            Body bodyOne = new Body(),
                bodyTwo = new Body();
            bodyOne.name = "Vlad Tepesz";
            bodyOne.birthDate = new DateTime(1700, 01, 01);
            bodyOne.deathDate = new DateTime(1970, 12, 31);
            bodyOne.id = 1;
            bodyOne.isVampire = true;
            Grave grave = new Grave();
            grave.id = 1;
            grave.column = 1;
            grave.row = 1;
            grave.capacity = 2;
            try
            {
                manager.burryBodyIntoGrave(bodyOne, grave);
            }
            catch(Exception ex)
            {
                Console.Error.WriteLine("Cannot burry first body: " + ex);
            }

            bodyTwo.name = "Obet Lucy";
            bodyTwo.id = 2;
            bodyTwo.isVampire = false;
            bodyTwo.birthDate = new DateTime(1900, 02, 02);
            bodyTwo.deathDate = new DateTime(1932, 01, 01);
            try
            {
                manager.burryBodyIntoGrave(bodyTwo, grave);
            }
            catch(Exception ex)
            {
                Console.Error.WriteLine("Cannot burry second body:" + ex);
            }

            Console.WriteLine(manager.findGraveWithBody(bodyTwo));
            foreach(Body body in manager.getBodiesInGrave(grave))
            {
                Console.WriteLine(body);
            }

            try
            {
                manager.burryBodyIntoGrave(bodyTwo, grave);
                Console.Error.WriteLine("Burrying third body into grave should fail.");
            }
            catch(Exception ex)
            {
                Console.WriteLine("Unable to burry third body into grave with capacity 2.");
            }
            Console.ReadLine();

        }
    }
}
